import { Component, ViewChild, OnInit, OnDestroy, ElementRef, ViewContainerRef, TemplateRef } from '@angular/core';
import { DiagramComponent } from '@syncfusion/ej2-angular-diagrams';
import {
  Diagram, NodeModel, UndoRedo, ConnectorModel, PointPortModel, Connector, FlowShapeModel,
  SymbolInfo, IDragEnterEventArgs, SnapSettingsModel, MarginModel, TextStyleModel, StrokeStyleModel,
  OrthogonalSegmentModel, Node, PaletteModel
} from '@syncfusion/ej2-diagrams';
import { ExpandMode } from '@syncfusion/ej2-navigations';
import { PanelModel, DashboardLayoutComponent } from '@syncfusion/ej2-angular-layouts';
import { DiagramtestComponent } from './diagramtest.component';
/**
 * Default FlowShape sample
 */

@Component({
  selector: 'app-root',
  templateUrl: 'app.component.html',
  styleUrls: ['app.component.css']
})
export class AppComponent {
  @ViewChild('api_dashboard', { static: false })
  public dashboardObject: DashboardLayoutComponent | undefined;
  @ViewChild('container', { read: ElementRef, static: true }) container: ElementRef;
  @ViewChild('dashboarddiv', { static: false })
  public dashboarddiv: ElementRef
  public cellSpacing: number[] = [3, 3];
  public mediaQuery: string = 'max-width: 700px';
  public panels: PanelModel[] = [];
  public resizableHandles: string[] = ['e-south-east', 'e-east', 'e-west', 'e-north', 'e-south'];
  public targetElement: HTMLElement;
  isAdmin = true;
  userId: number;
  allowEdit: boolean = true;
  users: any = [];
  display: string = 'Content to Display';
  isUpdated: boolean = false;
  showLeftSidebar: boolean = true;
  @ViewChild('viewContainer', { read: ViewContainerRef, static: true }) viewContainer: ViewContainerRef;
  @ViewChild('CustomTemplate', { static: true }) CustomTemplate: TemplateRef<any>;
  @ViewChild('rackview', { static: false }) rackdiagram: DiagramtestComponent;
 
  LoadUserDashboard() {
    if (this.dashboardObject !== undefined) {
      this.dashboardObject.removeAll();
     // let diagram: DiagramComponent;
      //diagram.
      let panel: PanelModel = {
        'id': '1', 'sizeX': 2, 'sizeY': 1, 'row': 0, 'col': 1, 'maxSizeX':4, 'maxSizeY': 4, 'minSizeX': 1, 'minSizeY': 1,
        
        header: '<span id="close" class="e-template-icon e-close-icon"></span><div>Rack Widget</div>'
      };
      
      this.dashboardObject.addPanel(panel);
      //this.dashboardObject.addPanel(panel2);
      const templateValue = this.CustomTemplate.createEmbeddedView(null);
      // inserts the template into the view container
      this.viewContainer.insert(templateValue);
      // Obtaining the content element of the panel
      let panel_Content = document.getElementById("1" + "_content");
      
      // appending the template to the panel content element.
      panel_Content.appendChild(templateValue.rootNodes[0]);   


      this.dashboardObject.refresh();
    }
    this.isUpdated = true;
  }
  
  onDashboardCreated(e: any) {
    this.LoadUserDashboard();
  }
  onResizeStop(args: any) {
    if (args.element.id == 1) {
      this.rackdiagram.diagram.height = document.getElementById(args.element.id + '_content').clientHeight;
      this.rackdiagram.diagram.width = document.getElementById(args.element.id + '_content').clientWidth;
     this.loadDiagram();
    }
    
  }
  loadDiagram(){
    this.rackdiagram.loadDiagram();
  }

}